diff --git a/tests/lowalgos/classifier/bug28211_4 b/tests/lowalgos/classifier/bug28211_4
new file mode 100644
index 0000000..51ca604
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_4
@@ -0,0 +1,69 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# We create new face, which is not-closed in 2D-space.
+# This gap is covered by the tolerance of the vertex
+# and this vertex is shared between two edges.
+# After that, point is classified, which is
+# out of the face UV-bounds.
+
+box b1 10 10 1
+copy b1 b2
+btranslate b2 -10 0 0
+sewing bb b1 b2
+
+explode bb f
+
+explode bb_7 v
+copy bb_7_2 v1
+copy bb_7_3 v2
+copy bb_7_4 v3
+settolerance v1 1.5
+
+explode bb_7 e
+emptycopy e1 bb_7_2
+emptycopy e2 bb_7_3
+emptycopy e3 bb_7_4
+
+add v1 e1
+copy v1 v1c
+orientation v1c F
+
+add v2 e1
+copy v2 v2c
+orientation v2c R
+
+add v2c e2
+add v3 e2
+copy v3 v3c
+orientation v3c R
+
+add v3c e3
+add v1c e3
+
+wire w1 e1 e2 e3
+
+buildfaces f1 bb_7 w1
+explode f1 f
+copy f1_1 result
+
+checkshape result
+
+point pp 0.5 10
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of b2dclassifx algorithm"
+} else {
+    puts "OK : Good result of b2dclassifx algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of b2dclassify algorithm"
+} else {
+    puts "OK : Good result of b2dclassify algorithm"
+}
diff --git a/tests/lowalgos/classifier/bug28211_40 b/tests/lowalgos/classifier/bug28211_40
new file mode 100644
index 0000000..bd04244
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_40
@@ -0,0 +1,49 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The classified face is based on the sphere and seems to be valid.
+# Check "-na" option for "b2dclassifx"-DRAW-command.
+
+pcylinder rr 3 5
+explode rr f
+copy rr_1 result
+
+point p1 0 2
+point p2 -2*pi 2
+
+if { ![regexp {ON} [ b2dclassifx result p1 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {ON} [ b2dclassifx result p1 -na ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {ON} [ b2dclassifx result p2 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result p2 -na ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display p1 p2
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/classifier/bug28211_5 b/tests/lowalgos/classifier/bug28211_5
new file mode 100644
index 0000000..7244b3d
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_5
@@ -0,0 +1,69 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# We create new face, which is not-closed in 2D-space.
+# This gap is covered by the tolerance of the vertex
+# and this vertex is shared between two edges.
+# After that, point is classified, which is
+# out of the face UV-bounds.
+
+box b1 10 10 1
+copy b1 b2
+btranslate b2 -10 0 0
+sewing bb b1 b2
+
+explode bb f
+
+explode bb_7 v
+copy bb_7_1 v1
+copy bb_7_2 v2
+copy bb_7_3 v3
+settolerance v3 1.5
+
+explode bb_7 e
+emptycopy e1 bb_7_1
+emptycopy e2 bb_7_2
+emptycopy e3 bb_7_4
+
+add v1 e1
+copy v1 v1c
+orientation v1c R
+
+add v2 e1
+copy v2 v2c
+orientation v2c F
+
+add v1c e2
+add v3 e2
+copy v3 v3c
+orientation v3c R
+
+add v3c e3
+add v2c e3
+
+wire w1 e1 e2 e3
+
+buildfaces f1 bb_7 w1
+explode f1 f
+copy f1_1 result
+
+checkshape result
+
+point pp 0.5 -20
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of b2dclassifx algorithm"
+} else {
+    puts "OK : Good result of b2dclassifx algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of b2dclassify algorithm"
+} else {
+    puts "OK : Good result of b2dclassify algorithm"
+}
diff --git a/tests/lowalgos/classifier/bug28211_6 b/tests/lowalgos/classifier/bug28211_6
new file mode 100644
index 0000000..f6efd53
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_6
@@ -0,0 +1,36 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# Classification the point on periodic face.
+
+restore [locate_data_file CTO904_pro14942a.rle] a 
+explode a f
+
+copy a_1 result
+
+checkshape result
+
+point pp 3.1415926535897949 1.3545376643853366
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of b2dclassifx algorithm"
+} else {
+    puts "OK : Good result of b2dclassifx algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of b2dclassify algorithm"
+} else {
+    puts "OK : Good result of b2dclassify algorithm"
+}
+
+v2d
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}.png
diff --git a/tests/lowalgos/classifier/bug28211_7 b/tests/lowalgos/classifier/bug28211_7
new file mode 100644
index 0000000..11dba1d
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_7
@@ -0,0 +1,60 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The face is self-interfered but valid because
+# this region is covered by the vertex tolerance
+
+restore [locate_data_file bug28211_cface7.brep] result
+
+checkshape result
+
+explode result v
+
+settolerance result_4 0.163
+
+point pp1 -0.00029719455450734507 0.99995519812621869
+point pp2 0.036074608113613113 0.51294657060594639
+point pp3 -0.017063862250566202 0.53745439961011532
+point pp4 0.003 0.55657429702171448
+
+# Points pp1, pp3 and pp4 are covered by the vertex tolerance.
+# Current version of the classifier does not take into account
+# of this fact and returns computed status. However,
+# this result can be wrong by the reason of self-interferences.
+
+if { ![regexp {OUT} [ b2dclassifx result pp1 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassifx result pp2 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {IN} [ b2dclassifx result pp3 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassifx result pp4 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+
+don pp2 pp3 pp4
+2dfit
+pcurve result
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}.png
diff --git a/tests/lowalgos/classifier/bug28211_9 b/tests/lowalgos/classifier/bug28211_9
new file mode 100644
index 0000000..56bf1e7
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_9
@@ -0,0 +1,29 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The face contains four edges.
+# However, one edge (result_4) is degenerated and,
+# more over, does not contain any p-curve on the face.
+# This face is obtained while debugging of the test case
+# "thrusection specific H7".
+
+restore [locate_data_file bug28211_sweepface.brep] result
+
+point pp -48.872643414172487 -4.1512836621766880
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of b2dclassifx algorithm"
+} else {
+    puts "OK : Good result of b2dclassifx algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of b2dclassify algorithm"
+} else {
+    puts "OK : Good result of b2dclassify algorithm"
+}
diff --git a/tests/lowalgos/classifier/bug29203_1 b/tests/lowalgos/classifier/bug29203_1
new file mode 100644
index 0000000..fc68faa
--- /dev/null
+++ b/tests/lowalgos/classifier/bug29203_1
@@ -0,0 +1,34 @@
+puts "========"
+puts "OCC29203"
+puts "========"
+puts ""
+#################################################
+# Different Point-Face-classification algorithms return different results
+#################################################
+
+# There is a dangerous to return ON-status by the reason
+# of poor algorithm of IntRes2d_Position computation
+# in BRepClass_Intersector class. Correct status is OUT.
+
+binrestore [locate_data_file bug29203_transface.bin] result
+fixshape result result
+checkshape result
+
+point pp 7.1206049999999994 0.17881000000000000
+
+v2d
+pcurve result
+2dfit
+checkview -screenshot -2d -path ${imagedir}/${test_image}.png
+
+if { ![regexp {OUT} [ b2dclassifx result pp -t 1.0e-7 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp -t 1.0e-7 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
diff --git a/tests/lowalgos/classifier/bug29203_2 b/tests/lowalgos/classifier/bug29203_2
new file mode 100644
index 0000000..103e98d
--- /dev/null
+++ b/tests/lowalgos/classifier/bug29203_2
@@ -0,0 +1,36 @@
+puts "========"
+puts "OCC29203"
+puts "========"
+puts ""
+#################################################
+# Different Point-Face-classification algorithms return different results
+#################################################
+
+# 3D-representation of the source point is in the 
+# wire of the source face (distance is
+# 3.039106595854385e-008). However, in 2D-space
+# the point is quite far from 2D-pcurve.
+# Current version of the algorithm must return
+# ON-status in these cases.
+
+restore [locate_data_file bug29203_toron.brep] result
+checkshape result
+
+point pp 1.6881493482012555 3.9044196877163997
+
+v2d
+pcurve result
+2dfit
+checkview -screenshot -2d -path ${imagedir}/${test_image}.png
+
+if { ![regexp {ON} [ b2dclassifx result pp -t 1.0e-7 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {ON} [ b2dclassify result pp -t 1.0e-7 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
diff --git a/tests/lowalgos/classifier/bug377 b/tests/lowalgos/classifier/bug377
new file mode 100644
index 0000000..4e0ff18
--- /dev/null
+++ b/tests/lowalgos/classifier/bug377
@@ -0,0 +1,99 @@
+pload QAcommands
+
+puts "========"
+puts "OCC377"
+puts "BUC61056"
+puts "========"
+puts ""
+###################################################################
+# Incorrect behaviour of BRepTopAdapter_FClass2d. 
+###################################################################
+
+# Two faces are created as copy of existing fsrc (have the same
+# surface and wire). However, the first face is created as NOT hole
+# (wire orientation is FORWARD) and the second face is created
+# as hole (wire orientation is REVERSED). Both faces are checked
+# by "ishole" DRAW-command.
+# Finally, some point pp is classified relatively to the every face.
+# Indeed, the classification result should be different for different
+# faces. However, thank to the huge tolerance (classifToler == 6.45)
+# the point pp must have the same status (ON) for both faces.
+
+set classifToler 6.45
+
+restore [locate_data_file OCC377.brep] fsrc
+point pp 1.9812 -0.9557948
+
+explode fsrc w
+copy fsrc_1 wirF
+copy fsrc_1 wirR
+
+orientation wirF F
+orientation wirR R
+
+# The face with the FORWARD wire
+
+emptycopy newface fsrc
+orientation newface F
+
+add wirF newface
+checknbshapes newface -face 1 -wire 1 -edge 8 -vertex 8 -t -m "Face building"
+
+if { ![regexp {The face is not hole} [ ishole newface -t $classifToler ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {ON} [ b2dclassifx newface pp -t $classifToler ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {ON} [ b2dclassify newface pp -t $classifToler ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+pcurve newface
+disp pp
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_forward.png
+
+# The face with the REVERSED wire
+
+emptycopy newface fsrc
+orientation newface F
+
+add wirR newface
+checknbshapes newface -face 1 -wire 1 -edge 8 -vertex 8 -t -m "Face building"
+
+if { ![regexp {The face is hole} [ ishole newface -t $classifToler ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {ON} [ b2dclassifx newface pp -t $classifToler ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {ON} [ b2dclassify newface pp -t $classifToler ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+2dclear
+pcurve newface
+disp pp
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_reversed.png
diff --git a/tests/lowalgos/classifier/bug538 b/tests/lowalgos/classifier/bug538
new file mode 100644
index 0000000..313371a
--- /dev/null
+++ b/tests/lowalgos/classifier/bug538
@@ -0,0 +1,43 @@
+puts "================"
+puts "OCC538"
+puts "================"
+puts ""
+
+restore [locate_data_file OCC538.brep] result 
+checkshape result
+
+puts [tolerance result]
+
+point pp 0.2453959532714904 -1.246869357124329
+
+if { ![regexp {ON} [ b2dclassifx result pp] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {ON} [ b2dclassify result pp] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {IN} [ b2dclassifx result pp -t 1.0e-7] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {IN} [ b2dclassify result pp -t 1.0e-7] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/grids.list b/tests/lowalgos/grids.list
index c3848ca..b1bb170 100644
--- a/tests/lowalgos/grids.list
+++ b/tests/lowalgos/grids.list
@@ -2,4 +2,5 @@
 002 bnd
 003 extcs
 004 extcc
-005 2dgcc
\ No newline at end of file
+005 2dgcc
+006 classifier
\ No newline at end of file
diff --git a/tests/lowalgos/parse.rules b/tests/lowalgos/parse.rules
index 610d206..0fd3201 100644
--- a/tests/lowalgos/parse.rules
+++ b/tests/lowalgos/parse.rules
@@ -1 +1,3 @@
 FAILED /\bFaulty\b/ bad shape
+FAILED /failure reading attribute/ attribute failure
+SKIPPED /Error: unsupported locale specification/ locale is unavailable on tested system
diff --git a/tests/sewing/tol_100/K1 b/tests/sewing/tol_100/K1
index 07e93e0..063af7a 100644
--- a/tests/sewing/tol_100/K1
+++ b/tests/sewing/tol_100/K1
@@ -1,5 +1,4 @@
 puts "TODO OCC24592 ALL: Error : Number of free edges is"
-puts "TODO OCC24592 ALL: Error : Number of faults is"
 restore [locate_data_file CNP002_projoiep.rle] a
 
 sewing result $tol a
-- 
1.9.5.msysgit.0

